<?php
defined('_JEXEC') or die('Access deny');
jimport('joomla.filesystem.folder');
include_once dirname(__FILE__) . '/csv.io.class.php';
class yandex_maps_export {
	static function getColumns($table) {
		$db = JFactory::getDbo();
		$db->setQuery('SHOW COLUMNS FROM #__yandex_maps_' . $table);
		return $db->loadColumn();
	}

	static function exportTable($table, $path, $titles = false, $params = []) {
		$db = JFactory::getDbo();

		$items = $db
			->setQuery('select * from #__yandex_maps_' . $table)
			->loadRowList();

		foreach ($items as &$item) {
			if ($table === 'objects' && (bool)$params['object_to_category_in_objects']) {
				$category_id = $db->setQuery(
					'select category_id from ' .
					$db->quoteName(
						'#__yandex_maps_object_to_category'
					) .
					' where object_id=' .
					(int) $item[0] .
					' limit 1'
				)
					->loadResult();

				array_splice( $item, 1, 0, [$category_id]);
			}


			foreach ($item as &$value) {
				$value = utf8_decode($value);
			}
		}

		$csv = new csv();

		if ($titles) {
			$titlesList = self::getColumns($table);

			if ($table === 'objects' && (bool)$params['object_to_category_in_objects']) {
				array_splice( $titlesList, 1, 0, ['category_id']);
			}

			if ($titlesList) {
				array_unshift($items, $titlesList);
			}
		}

		$csv->write($path . '/' . $table . '.csv', $items);
	}

	static function start($params) {
		set_time_limit(0);

		$path = dirname(__FILE__) . '/tmp';

		if (!is_dir($path)) {
			JFolder::create($path, '0755');
		}

		$res = false;
		$zip = null;

		if (class_exists('ZipArchive')) {
			$zip = new ZipArchive();
			$res = $zip->open($path . '/.exportzip', ZipArchive::CREATE);
		}

		$tables = [
			'maps',
			'categories',
			'objects',
			'organizations',
			'category_to_map',
			'object_to_category',
		];

		foreach ($tables as $table) {
			if ((int) $params[$table]) {
				// Не экспортируем в этом режиме таблицу связей
				if ($table === 'object_to_category' && (bool)$params['object_to_category_in_objects']) {
					continue;
				}

				self::exportTable($table, $path, (bool) $params['titles'], $params);

				if ($res) {
					$zip->addFile(
						$path . '/' . $table . '.csv',
						$table . '.csv'
					);
				} else {
					file_put_contents(
						$path . '/.exportdat',
						'#$#$|' .
							$table .
							'|$#$#' .
							file_get_contents($path . '/' . $table . '.csv'),
						FILE_APPEND
					);
				}
			}
		}

		if ((int) $params['settings']) {
			$setting = JComponentHelper::getParams(
				'com_yandex_maps'
			)->toString();

			if ($res) {
				$zip->addFromString('settings.json', $setting);
			} else {
				file_put_contents(
					$path . '/.exportdat',
					'#$#$|settings|$#$#' . $setting,
					FILE_APPEND
				);
			}
		}

		if ($res && $zip) {
			$zip->close();
		}

		header(
			'Content-Length: ' .
				filesize($path . '/.export' . ($res ? 'zip' : 'dat'))
		);
		header('Content-type: application/' . ($res ? 'zip' : 'octet-stream'));
		header(
			'Content-Disposition: attachment; filename=export.yandex.maps-' .
				date('d.m.Y-H-i') .
				'.' .
				($res ? 'zip' : 'dat')
		);
		header('Content-Transfer-Encoding: binary');

		if ($fd = fopen($path . '/.export' . ($res ? 'zip' : 'dat'), 'rb')) {
			while (!feof($fd)) {
				echo fread($fd, 1024);
			}
			fclose($fd);
		}

		@unlink($path . '/.export' . ($res ? 'zip' : 'dat'));
		@unlink($path . '/maps.csv');
		@unlink($path . '/categories.csv');
		@unlink($path . '/objects.csv');

		exit();
	}
}
